import * as $protobuf from "protobufjs";

/** Namespace proto. */
export namespace proto {

    /** Properties of a DataLeakage. */
    interface IDataLeakage {

        /** DataLeakage detections */
        detections?: proto.IDetection[];

        /** DataLeakage invocation */
        invocation?: proto.IInvocation;
    }

    /** Represents a DataLeakage. */
    class DataLeakage {

        /**
         * Constructs a new DataLeakage.
         * @param [properties] Properties to set
         */
        constructor(properties?: proto.IDataLeakage);

        /** DataLeakage detections. */
        public detections: proto.IDetection[];

        /** DataLeakage invocation. */
        public invocation?: (proto.IInvocation|null);

        /**
         * Creates a new DataLeakage instance using the specified properties.
         * @param [properties] Properties to set
         * @returns DataLeakage instance
         */
        public static create(properties?: proto.IDataLeakage): proto.DataLeakage;

        /**
         * Encodes the specified DataLeakage message. Does not implicitly {@link proto.DataLeakage.verify|verify} messages.
         * @param message DataLeakage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: proto.IDataLeakage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified DataLeakage message, length delimited. Does not implicitly {@link proto.DataLeakage.verify|verify} messages.
         * @param message DataLeakage message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: proto.IDataLeakage, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a DataLeakage message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns DataLeakage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.DataLeakage;

        /**
         * Decodes a DataLeakage message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns DataLeakage
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.DataLeakage;

        /**
         * Verifies a DataLeakage message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a DataLeakage message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns DataLeakage
         */
        public static fromObject(object: { [k: string]: any }): proto.DataLeakage;

        /**
         * Creates a plain object from a DataLeakage message. Also converts values to other types if specified.
         * @param message DataLeakage
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: proto.DataLeakage, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this DataLeakage to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a Detection. */
    interface IDetection {

        /** Detection ids */
        ids?: string;

        /** Detection name */
        name?: string;

        /** Detection description */
        description?: string;

        /** Detection type */
        type?: string[];

        /** Detection severity */
        severity?: number;

        /** Detection certainty */
        certainty?: number;

        /** Detection successful */
        successful?: boolean;

        /** Detection relevant */
        relevant?: boolean;

        /** Detection reason */
        reason?: proto.Detection.Reason;

        /** Detection generatedby */
        generatedby?: proto.GeneratedBy;

        /** Detection attack */
        attack?: boolean;

        /** Detection input */
        input?: string[];

        /** Detection errors */
        errors?: string[];

        /** Detection hash */
        hash?: (number|Long);

        /** Detection ruleHash */
        ruleHash?: (number|Long);

        /** Detection onKey */
        onKey?: string;

        /** Detection byInput */
        byInput?: string;

        /** Detection tags */
        tags?: string[];
    }

    /** Represents a Detection. */
    class Detection {

        /**
         * Constructs a new Detection.
         * @param [properties] Properties to set
         */
        constructor(properties?: proto.IDetection);

        /** Detection ids. */
        public ids: string;

        /** Detection name. */
        public name: string;

        /** Detection description. */
        public description: string;

        /** Detection type. */
        public type: string[];

        /** Detection severity. */
        public severity: number;

        /** Detection certainty. */
        public certainty: number;

        /** Detection successful. */
        public successful: boolean;

        /** Detection relevant. */
        public relevant: boolean;

        /** Detection reason. */
        public reason: proto.Detection.Reason;

        /** Detection generatedby. */
        public generatedby: proto.GeneratedBy;

        /** Detection attack. */
        public attack: boolean;

        /** Detection input. */
        public input: string[];

        /** Detection errors. */
        public errors: string[];

        /** Detection hash. */
        public hash: (number|Long);

        /** Detection ruleHash. */
        public ruleHash: (number|Long);

        /** Detection onKey. */
        public onKey: string;

        /** Detection byInput. */
        public byInput: string;

        /** Detection tags. */
        public tags: string[];

        /**
         * Creates a new Detection instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Detection instance
         */
        public static create(properties?: proto.IDetection): proto.Detection;

        /**
         * Encodes the specified Detection message. Does not implicitly {@link proto.Detection.verify|verify} messages.
         * @param message Detection message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: proto.IDetection, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Detection message, length delimited. Does not implicitly {@link proto.Detection.verify|verify} messages.
         * @param message Detection message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: proto.IDetection, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Detection message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Detection
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.Detection;

        /**
         * Decodes a Detection message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Detection
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.Detection;

        /**
         * Verifies a Detection message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Detection message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Detection
         */
        public static fromObject(object: { [k: string]: any }): proto.Detection;

        /**
         * Creates a plain object from a Detection message. Also converts values to other types if specified.
         * @param message Detection
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: proto.Detection, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Detection to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    namespace Detection {

        /** Reason enum. */
        enum Reason {
            KNOWN_ATTACK = 0,
            BEHAVIOUR = 1,
            KNOWN_TOOL = 2
        }
    }

    /** GeneratedBy enum. */
    enum GeneratedBy {
        BITBRAIN = 0,
        PLUGIN = 1,
        MODSECURITY = 2
    }

    /** Properties of an Invocation. */
    interface IInvocation {

        /** Invocation sqlInvocations */
        sqlInvocations?: proto.Invocation.ISQLInvocation[];
    }

    /** Represents an Invocation. */
    class Invocation {

        /**
         * Constructs a new Invocation.
         * @param [properties] Properties to set
         */
        constructor(properties?: proto.IInvocation);

        /** Invocation sqlInvocations. */
        public sqlInvocations: proto.Invocation.ISQLInvocation[];

        /**
         * Creates a new Invocation instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Invocation instance
         */
        public static create(properties?: proto.IInvocation): proto.Invocation;

        /**
         * Encodes the specified Invocation message. Does not implicitly {@link proto.Invocation.verify|verify} messages.
         * @param message Invocation message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: proto.IInvocation, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Invocation message, length delimited. Does not implicitly {@link proto.Invocation.verify|verify} messages.
         * @param message Invocation message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: proto.IInvocation, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an Invocation message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Invocation
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.Invocation;

        /**
         * Decodes an Invocation message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Invocation
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.Invocation;

        /**
         * Verifies an Invocation message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an Invocation message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Invocation
         */
        public static fromObject(object: { [k: string]: any }): proto.Invocation;

        /**
         * Creates a plain object from an Invocation message. Also converts values to other types if specified.
         * @param message Invocation
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: proto.Invocation, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Invocation to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    namespace Invocation {

        /** Properties of a SQLInvocation. */
        interface ISQLInvocation {

            /** SQLInvocation queries */
            queries?: proto.Invocation.SQLInvocation.IQuery[];

            /** SQLInvocation endpoint */
            endpoint?: { [k: string]: string };

            /** SQLInvocation prepareStatement */
            prepareStatement?: string;

            /** SQLInvocation prepareCall */
            prepareCall?: string;
        }

        /** Represents a SQLInvocation. */
        class SQLInvocation {

            /**
             * Constructs a new SQLInvocation.
             * @param [properties] Properties to set
             */
            constructor(properties?: proto.Invocation.ISQLInvocation);

            /** SQLInvocation queries. */
            public queries: proto.Invocation.SQLInvocation.IQuery[];

            /** SQLInvocation endpoint. */
            public endpoint: { [k: string]: string };

            /** SQLInvocation prepareStatement. */
            public prepareStatement: string;

            /** SQLInvocation prepareCall. */
            public prepareCall: string;

            /**
             * Creates a new SQLInvocation instance using the specified properties.
             * @param [properties] Properties to set
             * @returns SQLInvocation instance
             */
            public static create(properties?: proto.Invocation.ISQLInvocation): proto.Invocation.SQLInvocation;

            /**
             * Encodes the specified SQLInvocation message. Does not implicitly {@link proto.Invocation.SQLInvocation.verify|verify} messages.
             * @param message SQLInvocation message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encode(message: proto.Invocation.ISQLInvocation, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Encodes the specified SQLInvocation message, length delimited. Does not implicitly {@link proto.Invocation.SQLInvocation.verify|verify} messages.
             * @param message SQLInvocation message or plain object to encode
             * @param [writer] Writer to encode to
             * @returns Writer
             */
            public static encodeDelimited(message: proto.Invocation.ISQLInvocation, writer?: $protobuf.Writer): $protobuf.Writer;

            /**
             * Decodes a SQLInvocation message from the specified reader or buffer.
             * @param reader Reader or buffer to decode from
             * @param [length] Message length if known beforehand
             * @returns SQLInvocation
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.Invocation.SQLInvocation;

            /**
             * Decodes a SQLInvocation message from the specified reader or buffer, length delimited.
             * @param reader Reader or buffer to decode from
             * @returns SQLInvocation
             * @throws {Error} If the payload is not a reader or valid buffer
             * @throws {$protobuf.util.ProtocolError} If required fields are missing
             */
            public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.Invocation.SQLInvocation;

            /**
             * Verifies a SQLInvocation message.
             * @param message Plain object to verify
             * @returns `null` if valid, otherwise the reason why it is not
             */
            public static verify(message: { [k: string]: any }): (string|null);

            /**
             * Creates a SQLInvocation message from a plain object. Also converts values to their respective internal types.
             * @param object Plain object
             * @returns SQLInvocation
             */
            public static fromObject(object: { [k: string]: any }): proto.Invocation.SQLInvocation;

            /**
             * Creates a plain object from a SQLInvocation message. Also converts values to other types if specified.
             * @param message SQLInvocation
             * @param [options] Conversion options
             * @returns Plain object
             */
            public static toObject(message: proto.Invocation.SQLInvocation, options?: $protobuf.IConversionOptions): { [k: string]: any };

            /**
             * Converts this SQLInvocation to JSON.
             * @returns JSON object
             */
            public toJSON(): { [k: string]: any };
        }

        namespace SQLInvocation {

            /** Properties of a Query. */
            interface IQuery {

                /** Query query */
                query?: string;

                /** Query tables */
                tables?: string[];

                /** Query parameter */
                parameter?: { [k: string]: string };
            }

            /** Represents a Query. */
            class Query {

                /**
                 * Constructs a new Query.
                 * @param [properties] Properties to set
                 */
                constructor(properties?: proto.Invocation.SQLInvocation.IQuery);

                /** Query query. */
                public query: string;

                /** Query tables. */
                public tables: string[];

                /** Query parameter. */
                public parameter: { [k: string]: string };

                /**
                 * Creates a new Query instance using the specified properties.
                 * @param [properties] Properties to set
                 * @returns Query instance
                 */
                public static create(properties?: proto.Invocation.SQLInvocation.IQuery): proto.Invocation.SQLInvocation.Query;

                /**
                 * Encodes the specified Query message. Does not implicitly {@link proto.Invocation.SQLInvocation.Query.verify|verify} messages.
                 * @param message Query message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encode(message: proto.Invocation.SQLInvocation.IQuery, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Encodes the specified Query message, length delimited. Does not implicitly {@link proto.Invocation.SQLInvocation.Query.verify|verify} messages.
                 * @param message Query message or plain object to encode
                 * @param [writer] Writer to encode to
                 * @returns Writer
                 */
                public static encodeDelimited(message: proto.Invocation.SQLInvocation.IQuery, writer?: $protobuf.Writer): $protobuf.Writer;

                /**
                 * Decodes a Query message from the specified reader or buffer.
                 * @param reader Reader or buffer to decode from
                 * @param [length] Message length if known beforehand
                 * @returns Query
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.Invocation.SQLInvocation.Query;

                /**
                 * Decodes a Query message from the specified reader or buffer, length delimited.
                 * @param reader Reader or buffer to decode from
                 * @returns Query
                 * @throws {Error} If the payload is not a reader or valid buffer
                 * @throws {$protobuf.util.ProtocolError} If required fields are missing
                 */
                public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.Invocation.SQLInvocation.Query;

                /**
                 * Verifies a Query message.
                 * @param message Plain object to verify
                 * @returns `null` if valid, otherwise the reason why it is not
                 */
                public static verify(message: { [k: string]: any }): (string|null);

                /**
                 * Creates a Query message from a plain object. Also converts values to their respective internal types.
                 * @param object Plain object
                 * @returns Query
                 */
                public static fromObject(object: { [k: string]: any }): proto.Invocation.SQLInvocation.Query;

                /**
                 * Creates a plain object from a Query message. Also converts values to other types if specified.
                 * @param message Query
                 * @param [options] Conversion options
                 * @returns Plain object
                 */
                public static toObject(message: proto.Invocation.SQLInvocation.Query, options?: $protobuf.IConversionOptions): { [k: string]: any };

                /**
                 * Converts this Query to JSON.
                 * @returns JSON object
                 */
                public toJSON(): { [k: string]: any };
            }
        }
    }

    /** Properties of a Datapoint. */
    interface IDatapoint {

        /** Datapoint context */
        context?: { [k: string]: string };

        /** Datapoint errors */
        errors?: proto.IError[];

        /** Datapoint endpoint */
        endpoint?: { [k: string]: string };

        /** Datapoint meta */
        meta?: { [k: string]: string };

        /** Datapoint detections */
        detections?: proto.IDetection[];

        /** Datapoint input */
        input?: { [k: string]: string };

        /** Datapoint invocation */
        invocation?: proto.IInvocation;

        /** Datapoint vulnerabilities */
        vulnerabilities?: proto.IVulnerability[];

        /** Datapoint dataLeakages */
        dataLeakages?: proto.IDataLeakage[];

        /** Datapoint personalData */
        personalData?: { [k: string]: proto.IPersonalData };
    }

    /** Represents a Datapoint. */
    class Datapoint {

        /**
         * Constructs a new Datapoint.
         * @param [properties] Properties to set
         */
        constructor(properties?: proto.IDatapoint);

        /** Datapoint context. */
        public context: { [k: string]: string };

        /** Datapoint errors. */
        public errors: proto.IError[];

        /** Datapoint endpoint. */
        public endpoint: { [k: string]: string };

        /** Datapoint meta. */
        public meta: { [k: string]: string };

        /** Datapoint detections. */
        public detections: proto.IDetection[];

        /** Datapoint input. */
        public input: { [k: string]: string };

        /** Datapoint invocation. */
        public invocation?: (proto.IInvocation|null);

        /** Datapoint vulnerabilities. */
        public vulnerabilities: proto.IVulnerability[];

        /** Datapoint dataLeakages. */
        public dataLeakages: proto.IDataLeakage[];

        /** Datapoint personalData. */
        public personalData: { [k: string]: proto.IPersonalData };

        /**
         * Creates a new Datapoint instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Datapoint instance
         */
        public static create(properties?: proto.IDatapoint): proto.Datapoint;

        /**
         * Encodes the specified Datapoint message. Does not implicitly {@link proto.Datapoint.verify|verify} messages.
         * @param message Datapoint message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: proto.IDatapoint, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Datapoint message, length delimited. Does not implicitly {@link proto.Datapoint.verify|verify} messages.
         * @param message Datapoint message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: proto.IDatapoint, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Datapoint message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Datapoint
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.Datapoint;

        /**
         * Decodes a Datapoint message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Datapoint
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.Datapoint;

        /**
         * Verifies a Datapoint message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Datapoint message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Datapoint
         */
        public static fromObject(object: { [k: string]: any }): proto.Datapoint;

        /**
         * Creates a plain object from a Datapoint message. Also converts values to other types if specified.
         * @param message Datapoint
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: proto.Datapoint, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Datapoint to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a PersonalData. */
    interface IPersonalData {

        /** PersonalData value */
        value?: string[];
    }

    /** Represents a PersonalData. */
    class PersonalData {

        /**
         * Constructs a new PersonalData.
         * @param [properties] Properties to set
         */
        constructor(properties?: proto.IPersonalData);

        /** PersonalData value. */
        public value: string[];

        /**
         * Creates a new PersonalData instance using the specified properties.
         * @param [properties] Properties to set
         * @returns PersonalData instance
         */
        public static create(properties?: proto.IPersonalData): proto.PersonalData;

        /**
         * Encodes the specified PersonalData message. Does not implicitly {@link proto.PersonalData.verify|verify} messages.
         * @param message PersonalData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: proto.IPersonalData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified PersonalData message, length delimited. Does not implicitly {@link proto.PersonalData.verify|verify} messages.
         * @param message PersonalData message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: proto.IPersonalData, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a PersonalData message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns PersonalData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.PersonalData;

        /**
         * Decodes a PersonalData message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns PersonalData
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.PersonalData;

        /**
         * Verifies a PersonalData message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a PersonalData message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns PersonalData
         */
        public static fromObject(object: { [k: string]: any }): proto.PersonalData;

        /**
         * Creates a plain object from a PersonalData message. Also converts values to other types if specified.
         * @param message PersonalData
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: proto.PersonalData, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this PersonalData to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Represents a DatapointReceiver */
    class DatapointReceiver extends $protobuf.rpc.Service {

        /**
         * Constructs a new DatapointReceiver service.
         * @param rpcImpl RPC implementation
         * @param [requestDelimited=false] Whether requests are length-delimited
         * @param [responseDelimited=false] Whether responses are length-delimited
         */
        constructor(rpcImpl: $protobuf.RPCImpl, requestDelimited?: boolean, responseDelimited?: boolean);

        /**
         * Creates new DatapointReceiver service using the specified rpc implementation.
         * @param rpcImpl RPC implementation
         * @param [requestDelimited=false] Whether requests are length-delimited
         * @param [responseDelimited=false] Whether responses are length-delimited
         * @returns RPC service. Useful where requests and/or responses are streamed.
         */
        public static create(rpcImpl: $protobuf.RPCImpl, requestDelimited?: boolean, responseDelimited?: boolean): DatapointReceiver;

        /**
         * Calls receiveDatapoint.
         * @param request Datapoint message or plain object
         * @param callback Node-style callback called with the error, if any, and Reply
         */
        public receiveDatapoint(request: proto.IDatapoint, callback: proto.DatapointReceiver.receiveDatapointCallback): void;

        /**
         * Calls receiveDatapoint.
         * @param request Datapoint message or plain object
         * @returns Promise
         */
        public receiveDatapoint(request: proto.IDatapoint): Promise<proto.Reply>;
    }

    namespace DatapointReceiver {

        /**
         * Callback as used by {@link proto.DatapointReceiver#receiveDatapoint}.
         * @param error Error, if any
         * @param [response] Reply
         */
        type receiveDatapointCallback = (error: (Error|null), response?: proto.Reply) => void;
    }

    /** Properties of a Reply. */
    interface IReply {

        /** Reply message */
        message?: string;
    }

    /** Represents a Reply. */
    class Reply {

        /**
         * Constructs a new Reply.
         * @param [properties] Properties to set
         */
        constructor(properties?: proto.IReply);

        /** Reply message. */
        public message: string;

        /**
         * Creates a new Reply instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Reply instance
         */
        public static create(properties?: proto.IReply): proto.Reply;

        /**
         * Encodes the specified Reply message. Does not implicitly {@link proto.Reply.verify|verify} messages.
         * @param message Reply message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: proto.IReply, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Reply message, length delimited. Does not implicitly {@link proto.Reply.verify|verify} messages.
         * @param message Reply message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: proto.IReply, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Reply message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Reply
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.Reply;

        /**
         * Decodes a Reply message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Reply
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.Reply;

        /**
         * Verifies a Reply message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Reply message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Reply
         */
        public static fromObject(object: { [k: string]: any }): proto.Reply;

        /**
         * Creates a plain object from a Reply message. Also converts values to other types if specified.
         * @param message Reply
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: proto.Reply, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Reply to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of an Error. */
    interface IError {

        /** Error code */
        code?: number;

        /** Error description */
        description?: string;

        /** Error location */
        location?: string;

        /** Error line */
        line?: number;

        /** Error type */
        type?: string;

        /** Error generatedby */
        generatedby?: proto.GeneratedBy;

        /** Error hash */
        hash?: (number|Long);

        /** Error context */
        context?: string[];
    }

    /** Represents an Error. */
    class Error {

        /**
         * Constructs a new Error.
         * @param [properties] Properties to set
         */
        constructor(properties?: proto.IError);

        /** Error code. */
        public code: number;

        /** Error description. */
        public description: string;

        /** Error location. */
        public location: string;

        /** Error line. */
        public line: number;

        /** Error type. */
        public type: string;

        /** Error generatedby. */
        public generatedby: proto.GeneratedBy;

        /** Error hash. */
        public hash: (number|Long);

        /** Error context. */
        public context: string[];

        /**
         * Creates a new Error instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Error instance
         */
        public static create(properties?: proto.IError): proto.Error;

        /**
         * Encodes the specified Error message. Does not implicitly {@link proto.Error.verify|verify} messages.
         * @param message Error message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: proto.IError, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Error message, length delimited. Does not implicitly {@link proto.Error.verify|verify} messages.
         * @param message Error message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: proto.IError, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes an Error message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Error
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.Error;

        /**
         * Decodes an Error message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Error
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.Error;

        /**
         * Verifies an Error message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates an Error message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Error
         */
        public static fromObject(object: { [k: string]: any }): proto.Error;

        /**
         * Creates a plain object from an Error message. Also converts values to other types if specified.
         * @param message Error
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: proto.Error, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Error to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }

    /** Properties of a Vulnerability. */
    interface IVulnerability {

        /** Vulnerability line */
        line?: number;

        /** Vulnerability location */
        location?: string;

        /** Vulnerability error */
        error?: proto.IError;

        /** Vulnerability detection */
        detection?: proto.IDetection;

        /** Vulnerability invocation */
        invocation?: proto.IInvocation;

        /** Vulnerability type */
        type?: string;
    }

    /** Represents a Vulnerability. */
    class Vulnerability {

        /**
         * Constructs a new Vulnerability.
         * @param [properties] Properties to set
         */
        constructor(properties?: proto.IVulnerability);

        /** Vulnerability line. */
        public line: number;

        /** Vulnerability location. */
        public location: string;

        /** Vulnerability error. */
        public error?: (proto.IError|null);

        /** Vulnerability detection. */
        public detection?: (proto.IDetection|null);

        /** Vulnerability invocation. */
        public invocation?: (proto.IInvocation|null);

        /** Vulnerability type. */
        public type: string;

        /**
         * Creates a new Vulnerability instance using the specified properties.
         * @param [properties] Properties to set
         * @returns Vulnerability instance
         */
        public static create(properties?: proto.IVulnerability): proto.Vulnerability;

        /**
         * Encodes the specified Vulnerability message. Does not implicitly {@link proto.Vulnerability.verify|verify} messages.
         * @param message Vulnerability message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encode(message: proto.IVulnerability, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Encodes the specified Vulnerability message, length delimited. Does not implicitly {@link proto.Vulnerability.verify|verify} messages.
         * @param message Vulnerability message or plain object to encode
         * @param [writer] Writer to encode to
         * @returns Writer
         */
        public static encodeDelimited(message: proto.IVulnerability, writer?: $protobuf.Writer): $protobuf.Writer;

        /**
         * Decodes a Vulnerability message from the specified reader or buffer.
         * @param reader Reader or buffer to decode from
         * @param [length] Message length if known beforehand
         * @returns Vulnerability
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decode(reader: ($protobuf.Reader|Uint8Array), length?: number): proto.Vulnerability;

        /**
         * Decodes a Vulnerability message from the specified reader or buffer, length delimited.
         * @param reader Reader or buffer to decode from
         * @returns Vulnerability
         * @throws {Error} If the payload is not a reader or valid buffer
         * @throws {$protobuf.util.ProtocolError} If required fields are missing
         */
        public static decodeDelimited(reader: ($protobuf.Reader|Uint8Array)): proto.Vulnerability;

        /**
         * Verifies a Vulnerability message.
         * @param message Plain object to verify
         * @returns `null` if valid, otherwise the reason why it is not
         */
        public static verify(message: { [k: string]: any }): (string|null);

        /**
         * Creates a Vulnerability message from a plain object. Also converts values to their respective internal types.
         * @param object Plain object
         * @returns Vulnerability
         */
        public static fromObject(object: { [k: string]: any }): proto.Vulnerability;

        /**
         * Creates a plain object from a Vulnerability message. Also converts values to other types if specified.
         * @param message Vulnerability
         * @param [options] Conversion options
         * @returns Plain object
         */
        public static toObject(message: proto.Vulnerability, options?: $protobuf.IConversionOptions): { [k: string]: any };

        /**
         * Converts this Vulnerability to JSON.
         * @returns JSON object
         */
        public toJSON(): { [k: string]: any };
    }
}
