const Handler = require('../../handler/handler');
const moment = require('moment');
const { Endpoint } = require('../constants');

/**
 * Application handler for datapoints
 * @class ApplicationHandler
 * @extends {Handler}
 */
class ApplicationHandler extends Handler {
  constructor() {
    super();
    this.startupDate = moment().format('YYYY-MM-DDTHH:mm:ss.SSSZZ');
  }

  /**
   * Handles the datapoint
   * @param {Datapoint} datapoint 
   * @memberof ApplicationHandler
   */
  handle(datapoint) {
    if (this.config) {
      datapoint.endpoint[Endpoint.APPLICATION] = bitSensor.config.applicationName;
    }

    datapoint.endpoint[Endpoint.START_DATE] = this.startupDate;
  }
}

module.exports = ApplicationHandler;
