const Handler = require('../../handler/handler');
const moment = require('moment');
const { Endpoint } = require('../constants');
/**
 * Time handler for datapoints
 * @class TimeHandler
 * @extends {Handler}
 */
class TimeHandler extends Handler {
  /**
   * Handles the datapoint
   * @param {any} datapoint 
   * @memberof TimeHandler
   */
  handle(datapoint) {
    datapoint.endpoint[Endpoint.LOCALTIME] = moment().format('YYYY-MM-DDTHH:mm:ss.SSSZZ');
  }
}

module.exports = TimeHandler;
